#!/usr/bin/ruby
 
require 'serialport'
require 'time'
 
class String
   def to_dat
      b=self.to_num.scan(/../)
      dat=b[2]+"."+b[1]+"."+"20"+b[0]+" "+b[3]+":"+b[4]+":"+b[5]
      return dat
   end
 
   def to_num
      b=0
      tmp=""
      final=""
      self.each_char{ |f|
         if b==1
            final+=f+tmp
            b=0
         else
            tmp=f
            b=1
         end
      }
      return final
   end
 
   def to_read_utf
      final=""
      self.scan(/..../) {|xxx|
         final+= [xxx.to_s.to_i(16)].pack("U").freeze
      }
      return final
   end
 
   def to_read_txt
      cislo=""
      final=""
      count=2
      sms=self
      sms.scan(/../) { |hex|
         velikost=("%b" % hex.hex).length
 
         if velikost == 8 or count == sms.length
            octet = "%b" % hex.hex
         else
            octet = "0%b" % hex.hex  if velikost == 7
            octet = "00%b" % hex.hex  if velikost == 6
            octet = "000%b" % hex.hex  if velikost == 5
            octet = "0000%b" % hex.hex  if velikost == 4
            octet = "00000%b" % hex.hex  if velikost == 3
            octet = "000000%b" % hex.hex  if velikost == 2
         end
         cislo=octet+cislo
         count+=2
      }
      cislo.scan(/\d{7}/) {|septed|
         final+=septed.to_i(2).chr
      }
      return final.reverse
   end
 
end
 
 
class Time
   def to_cz
      strftime('%d.%m.%Y %H:%M:%S')
   end
end
 
class GSM
   SMSC = "+420733257555"
   def initialize()
      #port,baud,bits,stop
      @port = SerialPort.new("/dev/ttyUSB0",38400,8,1,SerialPort::NONE)
      cmd("AT")
      cmd("AT+CMGF=0")#0=PDU,1=TEXT
      cmd("AT+CSCA=\"#{SMSC}\"")#cslo
   end
   def close
      @port.close
   end
 
   def cmd(cmd)
      @port.write(cmd + "\r")
      wait
   end
   def wait
      buffer = ''
      while IO.select([@port], [], [], 0.25)
         chr = @port.getc.chr;
         buffer += chr
      end
      buffer
   end
 
   def pdu
      sms = cmd("AT+CMGL=4")
      sms.split().each{ |msg|
         msg.scan(/(\d+)(,\d,,)(\d+)/) {|id|
            p id[0]
 
         }
         msg.scan(/(..)(..)(.{12})(..)(..)(..)(.{12})(..)(..)(.{14})(..)(.*)/) {|part|
            p part[2].to_num
            p part[6].to_num
            p Time.parse(part[9]).to_cz
            puts part[11].to_read_utf if part[8] == "08"
            puts part[11].to_read_txt if part[8] == "00"
         }
         #cmd("AT+CMGD=1")#delete
      }
   end
 
end
 
mygsm = GSM.new()
mygsm.pdu
 
#0 Length of the SMSC information
#1 Type of address of SMSC
#2 SMSC number
#3 First octet of this SMS-DELIVER message.
#4 Length of the sender address
#5 Type of address of the sender number
#6 Sender number
#7 Protocol identifier
#8 Data encoding scheme
#9 Time stamp
#10 Length of User data (SMS message)
#11 User data
